/* Varianta patratica */
#include <fstream.h>
#define NMax 30001

int S[NMax];
int N;

void ReadData(void)
{ ifstream F("divizat.in");
  F >> N;
  for (int i=1; i<=N; F >> S[i++]);
}

int Left(int K)
/* True daca elementele din stanga lui K sunt mai mici ca el */
{ int i=K;
  while(i) if (S[i--]>S[K]) return 0;
  return 1;
}

int Right(int K)
/* True daca elementele din dreapta lui K sunt mai mari ca el */
{ int i=K;
  while(i<=(K<<1)-1) if (S[i++]<S[K]) return 0;
  return 1;
}

int Search(void)
{ int i;

  for (i=(N+1)>>1; !Right(i) || !Left(i); i--);
  return (i<<1)-1;
}

void main(void)
{
  ReadData();
  cout << Search() << '\n';
}
