{$M 65520,0,655360}

type stiva = Array[1..1000] of Word;

var n:Word;                    { n <= 1000                             }
    S:Array[1..2893] Of Char;  { 2893 = lungimea maxima cand n <= 1000 }
    i:Word;                    { Contor                                }
    lungsir:Word;              { Lungimea sirului S                    }
    st:stiva;                  { Stiva obtinuta din S                  }

{ Procedura de scriere a permutarii in cazul gasirii ei in fisierul "f.out" }

procedure scriere (st:stiva);

var f:Text;

begin
     Assign (f, 'f.out');
     ReWrite (f);
     for i := 1 to n do Write (f,st[i],' ');
     WriteLn(f);
     close (f);
end;

{ Procedura de testare a valabilitatii permutarii curente }

procedure testare (st:stiva);

var S1:Array[1..2893] Of Char;
    maxs1:Word;
    tmp:string;
    j:Word;
    c:Byte;
    convine:Boolean;

begin
     maxs1 := 0;
     for j := 1 to n do begin
         str(st[j],tmp);
         for c := 1 to Length (tmp) do begin
             maxs1 := maxs1 + 1;
             S1[maxs1] := tmp[c];
         end;
     end;
     convine := true;
     for j := 1 to lungsir do begin
         if S1[j] <> S[j] then convine := false;
     end;
     if convine then begin
        scriere(st);
        halt(0);
        { --------------------------------------- }
        { Aici trebuie sa se ajunga in cazul unui }
        { fisier de intrare introdus corect.      }
        { --------------------------------------- }
     end;
end;

{ Functie care testeaza corectitudinea construirii permutarii finale }

function testare_f (st:stiva;k:word):Boolean;

var S1:Array[1..2893] Of Char;
    maxs1:Word;
    tmp:string;
    j:Word;
    c:Byte;
    convine:Boolean;

begin
     maxs1 := 0;
     for j := 1 to k do begin
         str(st[j],tmp);
         for c := 1 to Length (tmp) do begin
             maxs1 := maxs1 + 1;
             S1[maxs1] := tmp[c];
         end;
     end;
     convine := true;
     for j := 1 to maxs1 do begin
         if S1[j] <> S[j] then convine := false;
     end;
     if convine then testare_f := true
                else testare_f := false;
end;

{ Functia de validare a permutarii (este sau nu permutare) }

function ev(st:stiva;k:word):boolean;

var a:Word;
    evv:Boolean;

begin
     evv := true;
     for a := 1 to k-1 do if st[k] = st[a] then evv := false;
     ev := evv;
end;

{ Procedura procedura principala de gasire a permutarii }
{ S-a folosit o procedura recursiva in loc de           }
{ backtracking, fiind mai rapida                        }

procedure procesare(k:Word);

var i:word;

begin
     for i:=1 to n do begin
         i := i - 1;
         repeat
               i := i + 1;
               st[k] := i;
         until (ev(st,k) and testare_f(st,k)) or (i > n);
         if (i <= n) then begin
            if (k = n) then begin
               testare(st);
            end else procesare (k+1);
         end else begin
             i := n;
         end;
     end;
end;

{ Procedura de citire a datelor de intrare din fisierul "f.in" }

procedure citire;

var f:text;

begin
     assign (f,'f.in');
     reset (f);
     i := 1;
     While not eof(f) do begin
        read (f,S[i]);
        Inc(i);
     end;
     Dec(i);
     if i < 10 then n := i;
     if (i >= 10) And (i <= 189) then begin
        n := (i-9) div 2;
        n := n + 9;
     end;
     if (i > 189) And (i <= 2889) then begin
        n := (i-189) div 3;
        n := n + 99;
     end;
     if i = 2893 then n := 1000;
     lungsir := i;
     close (f);
end;

var f:Text;

begin
     citire;
     procesare(1);
     { Daca se ajunge aici, inseamna ca fisierul }
     { de intrare a fost introdus gresit.        }
     Assign (f, 'f.out');
     ReWrite (f);
     WriteLn(f,'Fisierul de intrare a fost introdus gresit');
     close (f);
end.
