{$M 32767,0,0}

Program Alt_Soarece_Alt_Labirint;
Uses Crt;
Const Max = 40;
Type Dim = 1..Max;
     Matrice = ARRAY[Dim, Dim] Of Byte;
     Sir     = ARRAY[1..8] Of Integer;
               {    N NE  E SE  S SV  V NV}
Const x1  : Sir = (-1,-1, 0, 1, 1, 1, 0,-1);   {directii de miscare 1}
      y1  : Sir = ( 0, 1, 1, 1, 0,-1,-1,-1);
      x2  : Sir = ( 0, 1, 1, 1, 0,-1,-1,-1);   {directii de miscare 2}
      y2  : Sir = ( 1, 1, 0,-1,-1,-1, 0, 1);
      x3  : Sir = ( 1, 1, 0,-1,-1,-1, 0, 1);   {directii de miscare 3}
      y3  : Sir = ( 0,-1,-1,-1, 0, 1, 1, 1);
      x4  : Sir = ( 0,-1,-1,-1, 0, 1, 1, 1);   {directii de miscare 4}
      y4  : Sir = (-1,-1, 0, 1, 1, 1, 0,-1);
      Bit1 : Sir = ( 1, 2, 4, 8,16,32,64,128);  {verificare biti1}
      Bit2 : Sir = ( 4, 8,16,32,64,128,1, 2);   {verificare biti2}
      Bit3 : Sir = (16,32,64,128,1, 2, 4, 8);   {verificare biti3}
      Bit4 : Sir = (64,128,1, 2, 4, 8,16,32);   {verificare biti4}

Var Labirint, t : Matrice;                     {labirint si martor}
    i, j        : Integer;
   x0, y0, n, m : Dim;
           f, g : Text;
      Fin, Fout : String;
          LgMin : Word;                        {lungime minima}
    Drum, DrumM : Array[1..Max * Max] Of Word; {drum calculat si drum minim}
            Pas : Word;
      x, y, Bit : Sir;

Procedure Cit_Labirint;
Var i, j : Dim;
Begin
    {Write('Nume fisier intrare : '); ReadLn(Fin);}
    Assign(f, {Fin}'LABIRINT.IN'); Reset(f);
    {Write('Nume fisier iesire : '); ReadLn(Fout);}
    Assign(g, {Fout}'LABIRINT.OUT'); ReWrite(g);
    ReadLn(f, n, m);                          {citire n si m}
    For i := 1 To n Do                        {citire labirint}
        Begin
            For j := 1 To m Do Read(f, Labirint[i, j]);
            ReadLn(f)
        End;
    ReadLn(f, x0, y0);                        {punct de plecare soarece}
    Close(f);
End;

Procedure VerificTraseuMinim(Pas : Integer);
Begin
    If Pas < LgMin Then                       {am gasit un traseu mai mic?}
        Begin
            LgMin := Pas;                     {retine lungime}
            DrumM := Drum;                    {si drum}
        End;
End;

Procedure Traseu(i, j : Integer);
Var k, ii, jj : Integer;
Begin
    For k := 1 To 8 Do                        {incearca in cele 8 directii}
        Begin
            ii := i + x[k];                   {linie noua}
            jj := j + y[k];                   {coloana noua}
            If i + x[k]  In [1..n] Then             {daca e inca in labirint}
               If j + y[k] In [1..m] Then                 {si}
                  If Labirint[i, j] And Bit[k] <> 0 Then {e voie in directia asta}
                     If t[i + x[k], j + y[k]] = 0 Then    {daca nu a mai fost pe aici}
                        Begin                 {retine drum si numar pas}
                           t[i + x[k], j + y[k]] := Pas; Drum[Pas] := (i + x[k]) * (m + 1) + j + y[k];
                                              {daca a ajuns la o margine }
                           If (i + x[k] In [1, n]) Or (j + y[k] In [1, m]) Then VerificTraseuMinim(Pas)
                                              {verifica daca drumul gasit e mai scurt}
                           Else
                              Begin
                                  Inc(Pas);
                                  If Pas < LgMin Then  {daca nu a depasit drumul minim curent}
                                      Traseu(i + x[k], j + y[k]);  {incerc in continuare}
                                  Dec(Pas) {altfel inapoi pentru alt traseu }
                              End;
                           t[i + x[k], j + y[k]] := 0; Drum[Pas] := 0 {revino pe drum pentru alt traseu}
                        End;
        End;
End;

Procedure Det_Minim;
Var Unu, Doi, Trei, Patru : Word;
Begin
    Unu := (x0 - 1) * (m - y0 + 1);
    Doi := (n - x0 + 1) * (m - y0);
    Trei := (n - x0) * y0;
    Patru := x0 * (y0 - 1);
    If (Unu <= Doi) And (Unu <= Trei) And (Unu <= Patru) Then
        Begin
            x := x1; y := y1; Bit := Bit1
        End;
    If (Doi <= Unu) And (Doi <= Trei) And (Doi <= Patru) Then
        Begin
            x := x2; y := y2; Bit := Bit2
        End;
    If (Trei <= Doi) And (Trei <= Unu) And (Trei <= Patru) Then
        Begin
            x := x3; y := y3; Bit := Bit3
        End;
    If (Patru <= Doi) And (Patru <= Trei) And (Patru <= Unu) Then
        Begin
            x := x4; y := y4; Bit := Bit4
        End;
End;

Begin
    ClrScr;
    Cit_Labirint;
    Det_Minim;
    For i := 1 To n Do              {t - tablou martor}
        For j:= 1 To m Do t[i,j]:=0;
    t[x0, y0] := 1;                 {soarecele porneste de aici}
    LgMin := MaxInt;                {traseu de lungime maxima}
    Drum[1] := (m + 1) * x0 + y0;   {retin coordonatele (x0, y0)}
    Pas := 2;
    Traseu(x0, y0);                 {apelez procedura pentru pasul 2}
    If LgMin = MaxInt Then          {daca nu am gasit cel putin traseu}
        WriteLn(g, 'IMPOSIBIL')
    Else                            {altfel}
        Begin
            WriteLn(g, LgMin);      {scriu lungimea minima}
            For i := 1 To LgMin Do  {si drumul}
                WriteLn(g, DrumM[i] Div (m + 1), ' ', DrumM[i] Mod (m + 1))
        End;
    Close(g);
End.
