/* Varianta O(N log N), care merge bine */
#include <fstream.h>
#define NMax 30001

int S[NMax], far H[NMax], far HPos[NMax];
int N, HeapSize=0;

void ReadData(void)
{ ifstream F("divizat.in");
  F >> N;
  for (int i=1; i<=N; F >> S[i++]);
}

inline void Swap(int &A, int &B)
{ int T=A; A=B; B=T;
}

void HeapSift(int Tz)
/* Cerne al Tz-ulea element din Heap */
{ int Son;
  while (1) {
    if ((Son=Tz<<1)>HeapSize) return;
    if (Son<HeapSize && S[H[Son+1]]<S[H[Son]]) Son++;
    if (S[H[Son]]>S[H[Tz]]) return;
    HPos[H[Tz]]=Son;
    HPos[H[Son]]=Tz;
    Swap(H[Son], H[Tz]);
    Tz=Son;
  }
}

void HeapDelete(int Tz)
/* Sterge al Tz-ulea element din Heap */
{ HPos[H[HeapSize]]=Tz;
  H[Tz]=H[HeapSize--];     /* Il punem pe ultimul in loc... */
  HeapSift(Tz);            /* ... si il lasam sa cada */
}

void HeapAdd(int NewKid)
/* Adauga elementul S[NewKid] in Heap */
{ int Place=++HeapSize;
  HPos[NewKid]=Place;
  H[Place]=NewKid;
  while (Place>1 && S[H[Place]]<S[H[Place>>1]])
    { HPos[H[Place]]=Place>>1;
      HPos[H[Place>>1]]=Place;
      Swap(H[Place], H[Place>>1]);
      Place>>=1;
    }
}

int Search(void)
{ int MaxTillHere=S[1], LongestPrefix=1, j;

  HeapAdd(1);
  for(int i=2; i<=(N+1)>>1; i++)
    {
      if (S[i]>MaxTillHere) MaxTillHere=S[i];
      HeapDelete(HPos[i-1]);
      HeapAdd(2*i-2); HeapAdd(2*i-1);
      if (MaxTillHere==S[i] && S[H[1]]==S[i]) LongestPrefix=(i<<1)-1;
    }
  return LongestPrefix;
}

void main(void)
{
  ReadData();
  cout << Search() << '\n';
}
