{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}
type
  vector = array[1..30000] of integer;
  pvector = ^vector;

var
  v: vector;
  n: integer;
  maxsize: integer;
  size: integer;
  h: pvector;


procedure ReadData;
var
  fin: text;
  i: integer;
begin
  assign(fin, 'divizat.in');
  {$I-}
  reset(fin);
  {$I+}
  if(IOResult <> 0) then begin
    writeln('Cannot read divizat.in');
    halt;
  end;
  readln(fin, n);
  for i := 1 to n do read(fin, v[i]);
end;

procedure heap_insert(new : integer);
var
  i, j : integer;
  flag : boolean;
begin
  size := size + 1;
  j := size;
  flag := true;
  while flag and (j>1) do begin
    i := j div 2;
    if h^[i] <= new then flag := false
      else begin
        h^[j] := h^[i]; j := i
      end
    end;
    h^[j] := new;
end;

procedure siftup(i,n : integer );
var
  j: integer;
  tempr: integer;
begin
  while 2*i<=n do begin
    j := 2*i;
    if j<n then
      if h^[j] > h^[j+1] then j := j+1;
      if h^[i] > h^[j] then begin
        tempr := h^[j];
        h^[j] := h^[i];
        h^[i] := tempr;
        i := j
      end else i := size + 1
    end
end;

procedure heap_delete;
begin
  h^[1] := h^[size];
  size := size - 1;
  siftup(1, size);
end;

procedure ProcessData;
var
  maxleft: integer;
  i: integer;
  at: integer;
begin
  maxsize := 1;
  maxleft := 0;

  i := 3;
  maxleft := v[1];
  heap_insert(v[3]);
  while(i <= n) do begin
    at := v[trunc(i / 2) + 1];
    if((maxleft <= at) and (at <= h^[1])) then maxsize := i;
    if(maxleft < at) then maxleft := at;
    if(at = h^[1]) then heap_delete;
    heap_insert(v[i + 1]);
    i := i + 2;
  end;
end;

begin
  ReadData;

  new(h);
  size := 0;
  ProcessData;
  writeln(maxsize);
end.
