{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65520,0,655360}

type
  vector_byte = array[0..3000] of byte;
  vector_int = array[0..3000] of integer;
  vector_int_small = array[0..1000] of integer;

var
 n, len, llen: integer;
 len_list: vector_int;
 v: vector_byte;
 sol: vector_int_small;
 mark: vector_int;

procedure PrintSol;
var
  i: integer;
  fout: text;
begin
  assign(fout, 'f.out');
  rewrite(fout);
  for i := 1 to llen do write(fout, sol[i], ' ');
  close(fout);
  halt;
end;

procedure gen_len_list;

function get_no_chars(at: integer): byte;
var
  t: byte;
begin
  t := 0;
  while(at div 10 > 0) do begin
    at := at div 10;
    t := t + 1;
  end;

  get_no_chars := t + 1;
end;

var
  i, j: integer;
  c: byte;
begin
  i := 0; j := 0;
  while((i < 3000) and (j < 1000)) do begin
    j := j + 1;
    c := get_no_chars(j);
    i := i + c;
    len_list[i] := j;
  end;
end;

procedure ReadData;
var
  fin: text;
  c: char;
begin
  assign(fin, 'f.in');
  {$I-}
  reset(fin);
  {$I+}
  if(IOResult <> 0) then begin
    writeln('Cannot read f.in');
    halt;
  end;
  while(not(seekeof(fin))) do begin
    len := len + 1;
    read(fin, c);
    v[len] := ord(c) - 48;
  end;
end;

procedure ProcessData;

procedure Solve(k:integer);
var
  at: integer;
begin
  if llen = n then PrintSol;
  at := v[k];
  if at > n then exit;
  if(mark[at] = 0) then begin
    llen := llen + 1;
    sol[llen]:=at;
    mark[at] := k;
    Solve(k + 1);
    llen := llen - 1;
    mark[at] := 0;
  end;

  at := at * 10 + v[k + 1];
  if at > n then exit;

  if(mark[at] = 0) then begin
    llen := llen + 1;
    sol[llen] := at;
    mark[at] := k;
    Solve(k + 2);
    llen := llen - 1;
    mark[at] := 0;
  end;

  at := at * 10 + v[k + 2];
  if at > n then exit;

  if (mark[at] = 0) then begin
    llen := llen + 1;
    sol[llen] := at;
    mark[at] := k;
    Solve(k + 3);
    llen := llen - 1;
    mark[at] := 0;
  end;

  if((n = 1000) and (at = 100) and (v[k + 3] = 0)) then begin
    llen := llen + 1;
    sol[llen] := 1000;
    mark[1000] := k;
    Solve(k + 4);
    llen := llen - 1;
    mark[1000] := 0;
  end;
end;

begin
  n:=len_list[len];
  llen := 0;
  fillchar(mark, sizeof(mark), 0);
  mark[0] := 1;
  Solve(1);
end;

begin
  gen_len_list;
  ReadData;
  ProcessData;
end.