Program Verific_Solutii_Alt_Labirint;
Uses Crt;
Const Nord     = 1;
      NordEst  = 2;
      Est      = 4;
      SudEst   = 8;
      Sud      = 16;
      SudVest  = 32;
      Vest     = 64;
      NordVest = 128;
      Max      = 40;
      Puncte : Array[1..9] Of Byte = (2, 7, 2, 7, 4, 2, 6, 5, 10);

Type Dim = 1..Max;
     Matrice = ARRAY[Dim, Dim] Of Byte;

Var Fin, Fout, FSol, FPunct    : Text;
    Test, Sol, L1, L2          : String;
    LgMin, LgMinOK, Cod, i     : Integer;
    Labirint                   : Matrice;
    x0, y0, n, m, x, y, xu, yu : Dim;
    Corect                     : Boolean;
    Directie, NrTest, Punctaj  : Byte;

Procedure Cit_Labirint;
Var i, j : Dim;
Begin
    Assign(Fin, 'LABIRINT.IN'{'1.in'}); Reset(Fin);
    ReadLn(Fin, n, m);                      {citire n si m}
    For i := 1 To n Do                      {citire labirint}
        Begin
            For j := 1 To m Do Read(Fin, Labirint[i, j]);
            ReadLn(Fin)
        End;
    ReadLn(Fin, x0, y0);                    {punct de plecare soarece}
    Close(Fin);
End;

Begin
    {ClrScr;}
    Test := ParamStr(1); Val(Test[1], NrTest, Cod);
    Assign(FSol, Test{'1.ok'}); Reset(FSol);
    Assign(FPunct, 'PUNCTAJ.TXT');
    If NrTest = 1 Then
        ReWrite(FPunct)
    Else
        Append(FPunct);
    {$I-}
    Assign(Fout, 'LABIRINT.OUT'); Reset(Fout);
    {$I+}
    If IOResult <> 0 Then
        Begin
          WriteLn('Fisierul de ierire LABIRINT.OUT ABSENT! - 0 puncte');
          Punctaj := 0
        End
    Else
        Begin
          ReadLn(Fout, L1); ReadLn(FSol, L2);
          If (L1 = L2) And (L1 = 'IMPOSIBIL') Then
             Begin
                WriteLn('Test CORECT - ', Puncte[NrTest], ' puncte');
                Punctaj := Puncte[NrTest]
             End
          Else
             If ((L2 = 'IMPOSIBIL') And (L1 <> 'IMPOSIBIL')) Or
                ((L2 <> 'IMPOSIBIL') And (L1 = 'IMPOSIBIL')) Then
                Begin
                   WriteLn('Test INCORECT - 0 puncte');
                   Punctaj := 0
                End
             Else
                Begin
                   Val(L1, LgMin, Cod);
                   Val(L2, LgMinOK, Cod);
                   If LgMin > LgMinOK Then
                      Begin
                         WriteLn('Test INCORECT; Tu: ', LgMin, '  Corect: ', LgMinOK, ' 0 puncte');
                         Punctaj := 0
                      End
                   Else
                      Begin
                         Cit_Labirint;
                         ReadLn(Fout, x, y);
                         If (x <> x0) Or (y <> y0) Then
                            Begin
                               WriteLn('Test INCORECT - pleci din alt punct - 0 puncte');
                               Punctaj := 0;
                            End
                         Else
                            Begin
                               Corect := True;
                               i := 1;
                               While Not SeekEof(Fout) Do
                                  Begin
                                     ReadLn(Fout, xu, yu); Inc(i);
                                     If (Abs(xu - x) > 1) Or (Abs(yu - y) > 1) Then
                                        Begin
                                           Corect := False;
                                           WriteLn('Test INCORECT - sari prea departe!!! - 0 puncte');
                                           Punctaj := 0;
                                           Break
                                        End
                                     Else
                                        Begin
                                           If (x = xu) And (y + 1 = yu) Then Directie := Est;
                                           If (x = xu) And (y - 1 = yu) Then Directie := Vest;
                                           If (x + 1 = xu) And (y + 1 = yu) Then Directie := SudEst;
                                           If (x - 1 = xu) And (y - 1 = yu) Then Directie := NordVest;
                                           If (x + 1 = xu) And (y = yu) Then Directie := Sud;
                                           If (x - 1 = xu) And (y = yu) Then Directie := Nord;
                                           If (x - 1 = xu) And (y + 1 = yu) Then Directie := NordEst;
                                           If (x + 1= xu) And (y - 1 = yu) Then Directie := SudVest;
                                           If Labirint[x, y] And Directie = 0 Then
                                              Begin
                                                 Corect := False;
                                                 WriteLn('Test INCORECT - directie gresita!!! - 0 puncte');
                                                 Punctaj := 0;
                                                 Break
                                              End;
                                           x := xu;
                                           y := yu
                                        End
                                  End; {While}
                               If Corect And (i = LgMin) And ((xu In [1,n]) Or (yu In [1,m])) Then
                                  Begin
                                     WriteLn('Test CORECT ', Puncte[NrTest], ' puncte');
                                     Punctaj := Puncte[NrTest]
                                  End
                               Else
                                  Begin
                                     WriteLn('Test INCORECT - nu ai iesit sau lungime incorecta - 0 puncte');
                                     Punctaj := 0
                                  End
                            End {parcurgere LABIRINT.OUT}
                      End {lgmin bun}
                End{diferit de IMPOSIBIL}
        End; {prima linie din LABIRINT.OUT SI *.OK}
    WriteLn(FPunct, Punctaj);
    Close(Fout); Close(FSol); Close(Fpunct);
End.
